/*
	ProWesS, PROGS Windowing System

	digital clock, uses software generated events

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 4 February 1996
	06.05.1997 make sure we bail out when there are no software events
*/

#include <job.h>
#include <str.h>
#include <time.h>
#include <ProWesS.h>

#define MAXLEN 50

Error subjob(Job job)
{
	while (TRUE)
	{
		JOBEventSend(job,EVENT_LEVEL1);
		JOBSuspend(MYSELF,50*30,NULL);
	}
}

typedef struct {
	char *string;
	PWObject object;
} Global;

Error redraw(PWObject object)
{
	Global *g;
	Time time;
	char temp[22];

	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	TIMEGet(&time);
	TIMEString(time,temp);
	MEMCopy(17,temp,g->string);
	PWChange(g->object,PW_INFOSTRING_TEXT,g->string,NULL);
	return ERR_OK;
}

Error init()
{
	Job me;
	Error err;
	char time[]="9999 Wmm 99 99:99";
	Global g;
	WindowEvent event=EVENT_LEVEL1;

	g.string=time;

	JOBMe(&me);
	JOBCall(subjob,"clock events",1,1024,NULL,1,me);

	/* make sure we bail out if there are no software events */
	err=JOBEventWait(NOWAIT,&event);
	if (err==ERR_NIMP) return ERR_OK;

	PWCreate(NULL,&g.object,PW_TYPE_INFOSTRING,
				PW_INFOSTRING_TEXT, time,
				PW_GLOBAL_AUXILIARY, &g,
				PW_SYSTEM_ACTION_EVENT1, redraw,
				PW_WINDOW_BUTTON,
				PW_INFOSTRING_AUTOSIZE, FALSE,
				NULL);
	redraw(g.object);
	return PWActivate(g.object);
}
